import{s as Ue,n as Te,o as Me}from"../chunks/scheduler.182ea377.js";import{S as Le,i as Ee,g as o,s as a,r as l,A as Pe,h as r,f as t,c as i,j as h,u as d,x as O,k as _,y as g,a as n,v as m,d as f,t as u,w as c}from"../chunks/index.abf12888.js";import{D as S}from"../chunks/Docstring.93f6f462.js";import{H as G}from"../chunks/Heading.16916d63.js";function Be(ge){let v,Q,J,W,y,X,w,$e='The <a href="https://hf.co/papers/2301.11093" rel="nofollow">U-ViT</a> model is a vision transformer (ViT) based UNet. This model incorporates elements from ViT (considers all inputs such as time, conditions and noisy image patches as tokens) and a UNet (long skip connections between the shallow and deep layers). The skip connection is important for predicting pixel-level features. An additional 3x3 convolutional block is applied prior to the final output to improve image quality.',Y,x,be="The abstract from the paper is:",Z,V,ye="<em>Currently, applying diffusion models in pixel space of high resolution images is difficult. Instead, existing approaches focus on diffusion in lower dimensional spaces (latent diffusion), or have multiple super-resolution levels of generation referred to as cascades. The downside is that these approaches add additional complexity to the diffusion framework. This paper aims to improve denoising diffusion for high resolution images while keeping the model as simple as possible. The paper is centered around the research question: How can one train a standard denoising diffusion models on high resolution images, and still obtain performance comparable to these alternate approaches? The four main findings are: 1) the noise schedule should be adjusted for high resolution images, 2) It is sufficient to scale only a particular part of the architecture, 3) dropout should be added at specific locations in the architecture, and 4) downsampling is an effective strategy to avoid high resolution feature maps. Combining these simple yet effective techniques, we achieve state-of-the-art on image generation among diffusion models without sampling modifiers on ImageNet.</em>",ee,C,te,p,k,pe,$,D,ve,F,we="Sets the attention processor to use to compute attention.",he,b,U,_e,j,xe="Disables custom attention processors and sets the default attention implementation.",se,T,ne,M,L,ae,E,ie,P,B,oe,z,re,I,N,le,H,de,A,q,me,K,fe;return y=new G({props:{title:"UVit2DModel",local:"uvit2dmodel",headingTag:"h1"}}),C=new G({props:{title:"UVit2DModel",local:"diffusers.UVit2DModel",headingTag:"h2"}}),k=new S({props:{name:"class diffusers.UVit2DModel",anchor:"diffusers.UVit2DModel",parameters:[{name:"hidden_size",val:": int = 1024"},{name:"use_bias",val:": bool = False"},{name:"hidden_dropout",val:": float = 0.0"},{name:"cond_embed_dim",val:": int = 768"},{name:"micro_cond_encode_dim",val:": int = 256"},{name:"micro_cond_embed_dim",val:": int = 1280"},{name:"encoder_hidden_size",val:": int = 768"},{name:"vocab_size",val:": int = 8256"},{name:"codebook_size",val:": int = 8192"},{name:"in_channels",val:": int = 768"},{name:"block_out_channels",val:": int = 768"},{name:"num_res_blocks",val:": int = 3"},{name:"downsample",val:": bool = False"},{name:"upsample",val:": bool = False"},{name:"block_num_heads",val:": int = 12"},{name:"num_hidden_layers",val:": int = 22"},{name:"num_attention_heads",val:": int = 16"},{name:"attention_dropout",val:": float = 0.0"},{name:"intermediate_size",val:": int = 2816"},{name:"layer_norm_eps",val:": float = 1e-06"},{name:"ln_elementwise_affine",val:": bool = True"},{name:"sample_size",val:": int = 64"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/unets/uvit_2d.py#L39"}}),D=new S({props:{name:"set_attn_processor",anchor:"diffusers.UVit2DModel.set_attn_processor",parameters:[{name:"processor",val:": Union"}],parametersDescription:[{anchor:"diffusers.UVit2DModel.set_attn_processor.processor",description:`<strong>processor</strong> (<code>dict</code> of <code>AttentionProcessor</code> or only <code>AttentionProcessor</code>) &#x2014;
The instantiated processor class or a dictionary of processor classes that will be set as the processor
for <strong>all</strong> <code>Attention</code> layers.</p>
<p>If <code>processor</code> is a dict, the key needs to define the path to the corresponding cross attention
processor. This is strongly recommended when setting trainable attention processors.`,name:"processor"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/unets/uvit_2d.py#L241"}}),U=new S({props:{name:"set_default_attn_processor",anchor:"diffusers.UVit2DModel.set_default_attn_processor",parameters:[],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/unets/uvit_2d.py#L276"}}),T=new G({props:{title:"UVit2DConvEmbed",local:"diffusers.models.unets.uvit_2d.UVit2DConvEmbed",headingTag:"h2"}}),L=new S({props:{name:"class diffusers.models.unets.uvit_2d.UVit2DConvEmbed",anchor:"diffusers.models.unets.uvit_2d.UVit2DConvEmbed",parameters:[{name:"in_channels",val:""},{name:"block_out_channels",val:""},{name:"vocab_size",val:""},{name:"elementwise_affine",val:""},{name:"eps",val:""},{name:"bias",val:""}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/unets/uvit_2d.py#L292"}}),E=new G({props:{title:"UVitBlock",local:"diffusers.models.unets.uvit_2d.UVitBlock",headingTag:"h2"}}),B=new S({props:{name:"class diffusers.models.unets.uvit_2d.UVitBlock",anchor:"diffusers.models.unets.uvit_2d.UVitBlock",parameters:[{name:"channels",val:""},{name:"num_res_blocks",val:": int"},{name:"hidden_size",val:""},{name:"hidden_dropout",val:""},{name:"ln_elementwise_affine",val:""},{name:"layer_norm_eps",val:""},{name:"use_bias",val:""},{name:"block_num_heads",val:""},{name:"attention_dropout",val:""},{name:"downsample",val:": bool"},{name:"upsample",val:": bool"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/unets/uvit_2d.py#L307"}}),z=new G({props:{title:"ConvNextBlock",local:"diffusers.models.unets.uvit_2d.ConvNextBlock",headingTag:"h2"}}),N=new S({props:{name:"class diffusers.models.unets.uvit_2d.ConvNextBlock",anchor:"diffusers.models.unets.uvit_2d.ConvNextBlock",parameters:[{name:"channels",val:""},{name:"layer_norm_eps",val:""},{name:"ln_elementwise_affine",val:""},{name:"use_bias",val:""},{name:"hidden_dropout",val:""},{name:"hidden_size",val:""},{name:"res_ffn_factor",val:" = 4"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/unets/uvit_2d.py#L406"}}),H=new G({props:{title:"ConvMlmLayer",local:"diffusers.models.unets.uvit_2d.ConvMlmLayer",headingTag:"h2"}}),q=new S({props:{name:"class diffusers.models.unets.uvit_2d.ConvMlmLayer",anchor:"diffusers.models.unets.uvit_2d.ConvMlmLayer",parameters:[{name:"block_out_channels",val:": int"},{name:"in_channels",val:": int"},{name:"use_bias",val:": bool"},{name:"ln_elementwise_affine",val:": bool"},{name:"layer_norm_eps",val:": float"},{name:"codebook_size",val:": int"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/unets/uvit_2d.py#L451"}}),{c(){v=o("meta"),Q=a(),J=o("p"),W=a(),l(y.$$.fragment),X=a(),w=o("p"),w.innerHTML=$e,Y=a(),x=o("p"),x.textContent=be,Z=a(),V=o("p"),V.innerHTML=ye,ee=a(),l(C.$$.fragment),te=a(),p=o("div"),l(k.$$.fragment),pe=a(),$=o("div"),l(D.$$.fragment),ve=a(),F=o("p"),F.textContent=we,he=a(),b=o("div"),l(U.$$.fragment),_e=a(),j=o("p"),j.textContent=xe,se=a(),l(T.$$.fragment),ne=a(),M=o("div"),l(L.$$.fragment),ae=a(),l(E.$$.fragment),ie=a(),P=o("div"),l(B.$$.fragment),oe=a(),l(z.$$.fragment),re=a(),I=o("div"),l(N.$$.fragment),le=a(),l(H.$$.fragment),de=a(),A=o("div"),l(q.$$.fragment),me=a(),K=o("p"),this.h()},l(e){const s=Pe("svelte-u9bgzb",document.head);v=r(s,"META",{name:!0,content:!0}),s.forEach(t),Q=i(e),J=r(e,"P",{}),h(J).forEach(t),W=i(e),d(y.$$.fragment,e),X=i(e),w=r(e,"P",{"data-svelte-h":!0}),O(w)!=="svelte-19vq224"&&(w.innerHTML=$e),Y=i(e),x=r(e,"P",{"data-svelte-h":!0}),O(x)!=="svelte-1cwsb16"&&(x.textContent=be),Z=i(e),V=r(e,"P",{"data-svelte-h":!0}),O(V)!=="svelte-1c98hxn"&&(V.innerHTML=ye),ee=i(e),d(C.$$.fragment,e),te=i(e),p=r(e,"DIV",{class:!0});var R=h(p);d(k.$$.fragment,R),pe=i(R),$=r(R,"DIV",{class:!0});var ue=h($);d(D.$$.fragment,ue),ve=i(ue),F=r(ue,"P",{"data-svelte-h":!0}),O(F)!=="svelte-1o77hl2"&&(F.textContent=we),ue.forEach(t),he=i(R),b=r(R,"DIV",{class:!0});var ce=h(b);d(U.$$.fragment,ce),_e=i(ce),j=r(ce,"P",{"data-svelte-h":!0}),O(j)!=="svelte-1lxcwhv"&&(j.textContent=xe),ce.forEach(t),R.forEach(t),se=i(e),d(T.$$.fragment,e),ne=i(e),M=r(e,"DIV",{class:!0});var Ve=h(M);d(L.$$.fragment,Ve),Ve.forEach(t),ae=i(e),d(E.$$.fragment,e),ie=i(e),P=r(e,"DIV",{class:!0});var Ce=h(P);d(B.$$.fragment,Ce),Ce.forEach(t),oe=i(e),d(z.$$.fragment,e),re=i(e),I=r(e,"DIV",{class:!0});var ke=h(I);d(N.$$.fragment,ke),ke.forEach(t),le=i(e),d(H.$$.fragment,e),de=i(e),A=r(e,"DIV",{class:!0});var De=h(A);d(q.$$.fragment,De),De.forEach(t),me=i(e),K=r(e,"P",{}),h(K).forEach(t),this.h()},h(){_(v,"name","hf:doc:metadata"),_(v,"content",ze),_($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),_(b,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),_(p,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),_(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),_(P,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),_(I,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),_(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,s){g(document.head,v),n(e,Q,s),n(e,J,s),n(e,W,s),m(y,e,s),n(e,X,s),n(e,w,s),n(e,Y,s),n(e,x,s),n(e,Z,s),n(e,V,s),n(e,ee,s),m(C,e,s),n(e,te,s),n(e,p,s),m(k,p,null),g(p,pe),g(p,$),m(D,$,null),g($,ve),g($,F),g(p,he),g(p,b),m(U,b,null),g(b,_e),g(b,j),n(e,se,s),m(T,e,s),n(e,ne,s),n(e,M,s),m(L,M,null),n(e,ae,s),m(E,e,s),n(e,ie,s),n(e,P,s),m(B,P,null),n(e,oe,s),m(z,e,s),n(e,re,s),n(e,I,s),m(N,I,null),n(e,le,s),m(H,e,s),n(e,de,s),n(e,A,s),m(q,A,null),n(e,me,s),n(e,K,s),fe=!0},p:Te,i(e){fe||(f(y.$$.fragment,e),f(C.$$.fragment,e),f(k.$$.fragment,e),f(D.$$.fragment,e),f(U.$$.fragment,e),f(T.$$.fragment,e),f(L.$$.fragment,e),f(E.$$.fragment,e),f(B.$$.fragment,e),f(z.$$.fragment,e),f(N.$$.fragment,e),f(H.$$.fragment,e),f(q.$$.fragment,e),fe=!0)},o(e){u(y.$$.fragment,e),u(C.$$.fragment,e),u(k.$$.fragment,e),u(D.$$.fragment,e),u(U.$$.fragment,e),u(T.$$.fragment,e),u(L.$$.fragment,e),u(E.$$.fragment,e),u(B.$$.fragment,e),u(z.$$.fragment,e),u(N.$$.fragment,e),u(H.$$.fragment,e),u(q.$$.fragment,e),fe=!1},d(e){e&&(t(Q),t(J),t(W),t(X),t(w),t(Y),t(x),t(Z),t(V),t(ee),t(te),t(p),t(se),t(ne),t(M),t(ae),t(ie),t(P),t(oe),t(re),t(I),t(le),t(de),t(A),t(me),t(K)),t(v),c(y,e),c(C,e),c(k),c(D),c(U),c(T,e),c(L),c(E,e),c(B),c(z,e),c(N),c(H,e),c(q)}}}const ze='{"title":"UVit2DModel","local":"uvit2dmodel","sections":[{"title":"UVit2DModel","local":"diffusers.UVit2DModel","sections":[],"depth":2},{"title":"UVit2DConvEmbed","local":"diffusers.models.unets.uvit_2d.UVit2DConvEmbed","sections":[],"depth":2},{"title":"UVitBlock","local":"diffusers.models.unets.uvit_2d.UVitBlock","sections":[],"depth":2},{"title":"ConvNextBlock","local":"diffusers.models.unets.uvit_2d.ConvNextBlock","sections":[],"depth":2},{"title":"ConvMlmLayer","local":"diffusers.models.unets.uvit_2d.ConvMlmLayer","sections":[],"depth":2}],"depth":1}';function Ie(ge){return Me(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Se extends Le{constructor(v){super(),Ee(this,v,Ie,Be,Ue,{})}}export{Se as component};
